'
'
' ####################
' #####  PROLOG  #####
' ####################
'
' Test proplist control. Note that only one instance of this control is possible.
'
VERSION	"0.0001"
'
'	IMPORT  "xst_s.lib"
'	IMPORT  "xsx_s.lib"
'	IMPORT  "xio_s.lib"
	IMPORT	"xst"   		' standard library	: required by most programs
	IMPORT  "xsx"				' extended std library
'	IMPORT	"xio"				' console io library
	IMPORT	"gdi32"     ' gdi32.dll
	IMPORT  "user32"    ' user32.dll
	IMPORT  "kernel32"  ' kernel32.dll
	IMPORT  "comctl32"	' comctl32.dll			: common controls library
	IMPORT  "proplistbox"
'
DECLARE FUNCTION Entry            ()
DECLARE FUNCTION WndProc          (hwnd, msg, wParam, lParam)
DECLARE FUNCTION InitGui          ()
DECLARE FUNCTION CreateWindows    ()
DECLARE FUNCTION NewWindow        (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
DECLARE FUNCTION NewChild         (className$, text$, style, x, y, w, h, parent, id, exStyle)
DECLARE FUNCTION MessageLoop      ()
DECLARE FUNCTION GetNotifyMsg     (lParam, @hwndFrom, @idFrom, @code)
DECLARE FUNCTION CreateProps (hPropList)


$$IDC_PROPLIST = 100
'
' ######################
' #####  Entry ()  #####
' ######################
'
FUNCTION Entry ()

	STATIC	entry
'
	IF entry THEN RETURN							' enter once
	entry =  $$TRUE										' enter occured

	InitGui ()												' initialize program and libraries
	IF CreateWindows () THEN QUIT (0)	' create windows and other child controls
	MessageLoop ()										' the main message loop

END FUNCTION
'
'
' ########################
' #####  WndProc ()  #####
' ########################
'
FUNCTION WndProc (hWnd, msg, wParam, lParam)

	NMPROPLISTMODIFIED nmplm
	PROPLIST_PROPERTY plp

	SELECT CASE msg

		CASE $$WM_CREATE :
			hPropList = NewChild ($$PROPLISTBOXCLASSNAME, "", style, 10, 10, 250, 290, hWnd, $$IDC_PROPLIST, exStyle)
			CreateProps (hPropList)
			
'			SendMessageA (hPropList, $$PROPLIST_CLEARPROPDATA, 0, 0)
			
		CASE $$WM_DESTROY :
			PostQuitMessage(0)

		CASE $$WM_NOTIFY :
			idCtrl = wParam
			SELECT CASE idCtrl
				CASE $$IDC_PROPLIST :
					GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)
					? "Notify Message: hwndFrom=", hwndFrom, " idFrom=", idFrom, " code=", code
					
					' get currently selected item from nmplm struct
					XstCopyMemory (lParam, &nmplm, SIZE(nmplm))
					? "Notify Message: current selection index="; nmplm.curSel
					
					' or get selection index by using $$PROPLIST_GETCURSEL message 
					cs = SendMessageA (GetDlgItem(hWnd, $$IDC_PROPLIST), $$PROPLIST_GETCURSEL, 0, 0)
					? "Current Index :"; cs
					
					' get the property data at current selection
					lpPLP = SendMessageA (GetDlgItem(hWnd, $$IDC_PROPLIST), $$PROPLIST_GETPROPDATA, 0, cs) 
					IF lpPLP THEN
						PropList_GetProps (lpPLP, @name$, @curValue$, @defValue$, @itemType, @comboItems$, @dataType$, @category$, @help$)
						? "Name          :"; name$
						? "Current Value :"; curValue$
						? "Default Value :"; defValue$
						? "Item Type     :"; itemType
						? "Combo Items   :"; comboItems$
						? "Data Type     :"; dataType$
						? "Category      :"; category$
						? "Help String   :"; help$
					END IF
			END SELECT

		CASE $$WM_SIZE :
			w = LOWORD (lParam)
			h = HIWORD (lParam)
			MoveWindow (GetDlgItem(hWnd, $$IDC_PROPLIST), 0, 0, w, h, 1)
			
		CASE ELSE :
			RETURN DefWindowProcA (hWnd, msg, wParam, lParam)

	END SELECT

END FUNCTION
'
'
' ########################
' #####  InitGui ()  #####
' ########################
'
FUNCTION InitGui ()

	SHARED hInst
	
	hInst = GetModuleHandleA (0) 	' get current instance handle
	IFZ hInst THEN QUIT (0)
	InitCommonControls ()					' initialize comctl32.dll library
	
END FUNCTION
'
'
' ##############################
' #####  CreateWindows ()  #####
' ##############################
'
FUNCTION CreateWindows ()

	' create main window
	titleBar$ 	= "Property Listbox Control Test"
	style 			= $$WS_OVERLAPPEDWINDOW
	w 					= 280
	h 					= 340
	exStyle			= 0
	addrWndProc = &WndProc()
	icon$ 			= "scrabble"
	menu$ 			= ""
	#winMain = NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)
	IFZ #winMain THEN RETURN ($$TRUE)

	XstCenterWindow (#winMain)							' center window position
	ShowWindow (#winMain, $$SW_SHOWNORMAL)	' show window

END FUNCTION
'
'
' ##########################
' #####  NewWindow ()  #####
' ##########################
'
FUNCTION NewWindow (titleBar$, style, x, y, w, h, exStyle, addrWndProc, icon$, menu$)

	SHARED hInst
	WNDCLASS wc
	
	className$ = titleBar$
	IFZ className$ THEN className$ = "Main Program"
	IF INSTR(className$, " ") THEN
		XstReplace (@className$, " ", "_", 0)
	END IF
	
	IFZ icon$ THEN icon$ = "scrabble"
	
	wc.style           = $$CS_HREDRAW | $$CS_VREDRAW | $$CS_OWNDC
	wc.lpfnWndProc     = addrWndProc
	wc.cbClsExtra      = 0
	wc.cbWndExtra      = 0
	wc.hInstance       = hInst
	wc.hIcon           = LoadIconA (hInst, &icon$)
	wc.hCursor         = LoadCursorA (0, $$IDC_ARROW)
	wc.hbrBackground   = $$COLOR_BTNFACE + 1
	wc.lpszMenuName    = &menu$
	wc.lpszClassName   = &className$

	IFZ RegisterClassA (&wc) THEN RETURN
	RETURN CreateWindowExA (exStyle, &className$, &titleBar$, style, x, y, w, h, 0, 0, hInst, 0)

END FUNCTION
'
'
' #########################
' #####  NewChild ()  #####
' #########################
'
FUNCTION  NewChild (className$, text$, style, x, y, w, h, parent, id, exStyle)

	SHARED hInst

	style = style | $$WS_CHILD | $$WS_VISIBLE
	RETURN CreateWindowExA (exStyle, &className$, &text$, style, x, y, w, h, parent, id, hInst, 0)

END FUNCTION
'
'
' ############################
' #####  MessageLoop ()  #####
' ############################
'
FUNCTION MessageLoop ()

	MSG msg

' main message loop

	IF LIBRARY(0) THEN RETURN								' main program executes message loop

	DO																			' the message loop
		ret = GetMessageA (&msg, NULL, 0, 0)	' retrieve next message from queue

		SELECT CASE ret
			CASE  0 : RETURN msg.wParam					' WM_QUIT message
			CASE -1 : RETURN $$TRUE							' error
			CASE ELSE:
'				hwnd = GetActiveWindow ()
'				IF (!IsWindow (hwnd)) || (!IsDialogMessageA (hwnd, &msg)) THEN		' send only non-dialog messages
  				TranslateMessage (&msg)					' translate virtual-key messages into character messages
  				DispatchMessageA (&msg)					' send message to window callback function WndProc()
'				END IF
		END SELECT
	LOOP

END FUNCTION
'
' #############################
' #####  GetNotifyMsg ()  #####
' #############################
'
FUNCTION GetNotifyMsg (lParam, @hwndFrom, @idFrom, @code)

	NMHDR nmhdr
	nmhdrAddr = lParam
'	XstCopyMemory (nmhdrAddr, &nmhdr, SIZE(nmhdr))	'Xsx library function
	RtlMoveMemory (&nmhdr, nmhdrAddr, SIZE(nmhdr))	'kernel32 library function
	hwndFrom = nmhdr.hwndFrom
	idFrom   = nmhdr.idFrom
	code     = nmhdr.code

END FUNCTION
'
' #########################
' #####  CreateProps  #####
' #########################
'
'
'
FUNCTION CreateProps (hPropList)

	PROPLIST_PROPERTY this
	
	PropList_NewEditItem (@this, "Text", "New Text", "New Text", "S", "", "Sets window/control text.")
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 0, &this)
	
	help$ = "Returns/sets a value that determins where an object is displayed on a form."
	PropList_NewComboItem (@this, "Align", "0 - None", "0 - None", "0 - None|1 - Align Top|2 - Align Bottom|3 - Align Left|4 - Align Right", "L", "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 1, &this)
	
	help$ = "Returns/sets the background color used to display text and graphics in an object."
	color = GetSysColor ($$COLOR_BTNFACE)	
	PropList_NewColorItem (@this, "BackColor", color, color, "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 2, &this)
	
	help$ = "Returns/sets a graphic to be displayed in a control."
	PropList_NewFileItem (@this, "Picture", "test.bmp", "test.bmp", "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 3, &this)
	
	help$ = "Returns/sets a value that determines whether an object can respond to user-generated events."
	PropList_NewComboItem (@this, "Enabled", "True", "True", "True|False", "B", "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 4, &this)
	
	help$ = "Returns a font object."	
	PropList_NewFontItem (@this,"Font", "MS Sans Serif", "MS Sans Serif", "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 5, &this)
	
	help$ = "Returns/sets the distance between the internal top edge of an object and the top edge of its container."	
	PropList_NewEditItem (@this, "Top", "0", "0", "L", "", help$)
	SendMessageA (hPropList, $$PROPLIST_SETPROPDATA, 6, &this)


END FUNCTION

END PROGRAM
